From d23d81a1104d75ec874cef38661c3cc776d48239 Mon Sep 17 00:00:00 2001
From: nbv <nbv@opencascade.com>
Date: Fri, 29 Sep 2017 16:22:44 +0300
Subject: [PATCH 2/3] 0029203: Ambiguous behavior of Point-Face-classification
 algorithms: shall it return ON-status?

Correction of algorithm for check ON-status.

Now it uses native tolerance of edge (not external input tolerance).

Check, whether the classified point matches some vertex shall be added.
---
 src/AIS/AIS.cxx                                    |   2 +-
 src/AIS/AIS_LengthDimension.cxx                    |   2 +-
 src/BOPAlgo/BOPAlgo_BuilderFace.cxx                |   2 +-
 src/BOPTest/BOPTest_LowCommands.cxx                |  37 +-
 src/BOPTest/BOPTest_TolerCommands.cxx              |  42 +--
 src/BOPTools/BOPTools_AlgoTools2D.cxx              |   4 +-
 src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx           |   4 +-
 src/BRepAlgo/BRepAlgo_NormalProjection.cxx         |   6 +-
 src/BRepBndLib/BRepBndLib.cxx                      |   2 +-
 src/BRepCheck/BRepCheck_Face.cxx                   |   2 +-
 src/BRepClass/BRepClass_FaceClassifier.cxx         | 372 ++++++++-------------
 src/BRepClass/BRepClass_FaceClassifier.hxx         |  13 +-
 src/BRepClass/BRepClass_Intersector.cxx            |  69 +++-
 src/BRepClass/BRepClass_Intersector.hxx            |   2 +-
 src/BRepClass3d/BRepClass3d_Intersector3d.cxx      |   2 +-
 src/BRepClass3d/BRepClass3d_SolidExplorer.cxx      |   6 +-
 src/BRepExtrema/BRepExtrema_DistanceSS.cxx         |  27 +-
 src/BRepExtrema/BRepExtrema_ExtCF.cxx              |   3 +-
 src/BRepExtrema/BRepExtrema_ExtFF.cxx              |   7 +-
 src/BRepExtrema/BRepExtrema_ExtPF.cxx              |   3 +-
 src/BRepFeat/BRepFeat.cxx                          |   2 +-
 src/BRepFeat/BRepFeat_MakeRevolutionForm.cxx       |   2 +-
 src/BRepFeat/BRepFeat_RibSlot.cxx                  |   6 +-
 src/BRepLib/BRepLib.cxx                            |  34 +-
 src/BRepLib/BRepLib_FindSurface.cxx                |   2 +-
 src/BRepLib/BRepLib_MakeFace.cxx                   |   2 +-
 src/BRepOffset/BRepOffset_MakeOffset.cxx           |   2 +-
 src/BRepOffset/BRepOffset_Tool.cxx                 |   3 +-
 src/BRepOffsetAPI/BRepOffsetAPI_MakeOffset.cxx     |   2 +-
 src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx     |  37 +-
 src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx     |  11 +-
 src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx    |   6 +-
 src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx    |   3 +-
 src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx         |   2 +-
 src/Geom2dHatch/Geom2dHatch_Intersector.hxx        |   4 +-
 src/GeomliteTest/GeomliteTest_API2dCommands.cxx    |  28 +-
 src/IntImpParGen/IntImpParGen.cxx                  |  24 +-
 src/IntTools/IntTools_Context.cxx                  |   3 +-
 src/IntTools/IntTools_Tools.cxx                    |  11 +-
 src/LocOpe/LocOpe_SplitShape.cxx                   |   6 +-
 src/LocOpe/LocOpe_WiresOnShape.cxx                 |   2 +-
 src/SWDRAW/SWDRAW_ShapeAnalysis.cxx                |   3 +-
 src/SWDRAW/SWDRAW_ShapeFix.cxx                     |   2 +-
 src/ShapeAnalysis/ShapeAnalysis.cxx                |   3 +-
 src/ShapeFix/ShapeFix_ComposeShell.cxx             |   4 +-
 src/ShapeFix/ShapeFix_Face.cxx                     |   6 +-
 src/TNaming/TNaming.cxx                            |   3 +-
 src/TopClass/TopClass_Classifier2d.gxx             |  76 ++---
 .../TopOpeBRep_VPointInterClassifier.cxx           |  10 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_Builder1.cxx   |   2 +-
 .../TopOpeBRepBuild_CorrectFace2d.cxx              |   2 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_Tools.cxx      |   2 +-
 .../TopOpeBRepBuild_WireEdgeClassifier.cxx         |   3 +-
 src/TopOpeBRepBuild/TopOpeBRepBuild_ffsfs.cxx      |   3 +-
 src/TopOpeBRepTool/TopOpeBRepTool_CLASSI.cxx       |   4 +-
 .../TopOpeBRepTool_ShapeClassifier.cxx             |   3 +-
 src/TopOpeBRepTool/TopOpeBRepTool_face.cxx         |   2 +-
 tests/bugs/modalg_6/bug27341_206                   |  32 ++
 tests/lowalgos/classifier/bug23849_2               |  21 +-
 tests/lowalgos/classifier/bug29203_1               |   2 +-
 tests/lowalgos/classifier/bug29203_2               |   3 +-
 tests/lowalgos/classifier/bug538                   |   8 +-
 62 files changed, 478 insertions(+), 515 deletions(-)

diff --git a/src/AIS/AIS.cxx b/src/AIS/AIS.cxx
index 95203a1..b1cc36d 100644
--- a/src/AIS/AIS.cxx
+++ b/src/AIS/AIS.cxx
@@ -1219,7 +1219,7 @@ void AIS::InitLengthBetweenCurvilinearFaces (const TopoDS_Face&    theFirstFace,
     aProjector.Parameters (aBestPointIndex, aPU, aPV);
 
     // Now there is projection of FirstAttach onto SecondSurf in aProjector
-    BRepTopAdaptor_FClass2d aClassifier (theSecondFace, Precision::Confusion());
+    BRepTopAdaptor_FClass2d aClassifier (theSecondFace);
 
     TopAbs_State aState = aClassifier.Perform (gp_Pnt2d (aPU, aPV), Standard_True);
 
diff --git a/src/AIS/AIS_LengthDimension.cxx b/src/AIS/AIS_LengthDimension.cxx
index 6b91988..0e797e9 100755
--- a/src/AIS/AIS_LengthDimension.cxx
+++ b/src/AIS/AIS_LengthDimension.cxx
@@ -590,7 +590,7 @@ Standard_Boolean AIS_LengthDimension::InitTwoShapesPoints (const TopoDS_Shape& t
           Standard_Real anU, aV;
           ElSLib::Parameters (aSecondPlane, mySecondPoint, anU, aV);
 
-          BRepTopAdaptor_FClass2d aClassifier (aSecondFace, Precision::Confusion());
+          BRepTopAdaptor_FClass2d aClassifier (aSecondFace);
           TopAbs_State aState = aClassifier.Perform (gp_Pnt2d (anU, aV), Standard_False);
 
           if (aState == TopAbs_OUT || aState == TopAbs_UNKNOWN)
diff --git a/src/BOPAlgo/BOPAlgo_BuilderFace.cxx b/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
index 570636a..7d45e31 100644
--- a/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
+++ b/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
@@ -567,7 +567,7 @@ void BOPAlgo_BuilderFace::PerformAreas()
       }
 
       // update classifier
-      myContext->FClass2d(aFace).Init(aFace, aTol);
+      myContext->FClass2d(aFace).Init(aFace);
     }
 
     // The face is just a draft that does not contain any internal shapes
diff --git a/src/BOPTest/BOPTest_LowCommands.cxx b/src/BOPTest/BOPTest_LowCommands.cxx
index f682861..03ce4d3 100644
--- a/src/BOPTest/BOPTest_LowCommands.cxx
+++ b/src/BOPTest/BOPTest_LowCommands.cxx
@@ -74,9 +74,7 @@ static  Standard_Integer polyclassify( Draw_Interpretor&, Standard_Integer, cons
   const char* g = "BOPTest commands";
   theCommands.Add("bclassify"    , "use bclassify Solid Point [Tolerance=1.e-7]",
                   __FILE__, bclassify   , g);
-  theCommands.Add("b2dclassify", "use b2dclassify Face Point2d "
-                  "[-t Tol3D = <FaceToler>] :\n "
-                  "Tol3D is 3D-tolerance used for check ON-status.",
+  theCommands.Add("b2dclassify", "use b2dclassify Face Point2d \n "
                   __FILE__, b2dclassify , g);
   theCommands.Add("b2dclassifx"  , "use b2dclassifx Face Point2d "
                   "[-t Tol3D = <FaceToler>] [-na] :\n "
@@ -106,9 +104,8 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
                               const char**      theArgVec)
 {
   if (theArgNb < 3)  {
-    theDI << "Use b2dclassifx Face Point2d [-t Tol3D = <FaceToler>] [-na]:\n";
-    theDI << "Tol3D is 3D-tolerance used for check ON-status;\n"
-             "The option \"-na\" disables adjustment of 2d point in "
+    theDI << "Use b2dclassifx Face Point2d [-na]:\n";
+    theDI << "The option \"-na\" disables adjustment of 2d point in "
              "the domain of periodic face.\n";
     return 1;
   }
@@ -128,7 +125,6 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
   DrawTrSurf::GetPoint2d (theArgVec[2], aP);
   const TopoDS_Face&  aF   = TopoDS::Face(aS);
   
-  Standard_Real aTol3D = BRep_Tool::Tolerance(aF);
   Standard_Boolean isReqToAdjust = Standard_True;
 
   for (Standard_Integer aCurrArg = 3; aCurrArg < theArgNb; aCurrArg++)
@@ -138,9 +134,6 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
 
     switch (theArgVec[aCurrArg][1])
     {
-    case 't' :
-      aTol3D = Draw::Atof(theArgVec[++aCurrArg]);
-      break;
     case 'n' :
       if(!strncmp(theArgVec[aCurrArg], "-na", 3))
         isReqToAdjust = Standard_False;
@@ -150,7 +143,7 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
     }
   }
 
-  BRepTopAdaptor_FClass2d aClassifier(aF, aTol3D);
+  BRepTopAdaptor_FClass2d aClassifier(aF);
   const TopAbs_State aState = aClassifier.Perform(aP, isReqToAdjust);
   PrintState (theDI, aState);
   //
@@ -166,7 +159,7 @@ Standard_Integer b2dclassify (Draw_Interpretor& theDI,
                               const char**      theArgVec)
 {
   if (theArgNb < 3)  {
-    theDI << " use b2dclassify Face Point2d [-t Tol3D = <FaceToler>]\n";
+    theDI << " use b2dclassify Face Point2d\n";
     return 1;
   }
 
@@ -184,13 +177,14 @@ Standard_Integer b2dclassify (Draw_Interpretor& theDI,
   //
   DrawTrSurf::GetPoint2d (theArgVec[2], aP);
   const TopoDS_Face&  aF   = TopoDS::Face(aS);
-  Standard_Real aTol3D = BRep_Tool::Tolerance(aF);
 
   if ((theArgNb > 3) && (theArgVec[3][0] == '-') && (theArgVec[3][1] == 't'))
-    aTol3D = Draw::Atof(theArgVec[4]);
+  {
+    theDI << "ERROR!!! Wrong option \"-t\".\n";
+  }
 
   BRepClass_FaceClassifier aClassifier;
-  aClassifier.Perform(aF, aP, aTol3D);
+  aClassifier.Perform(aF, aP);
   PrintState (theDI, aClassifier.State());
   //
   return 0;
@@ -206,22 +200,13 @@ Standard_Integer IsHole(Draw_Interpretor& theDI,
 {
   if (theArgNb < 2)
   {
-    theDI << "Use: ishole face [-t Tol3D = <FaceToler>]\n";
+    theDI << "Use: ishole face \n";
     return 1;
   }
 
   TopoDS_Face aF = TopoDS::Face(DBRep::Get(theArgVec[1]));
 
-  Standard_Real aTol = BRep_Tool::Tolerance(aF);
-  for (Standard_Integer i = 2; i < theArgNb; i++)
-  {
-    if ((theArgVec[i][0] == '-') && (theArgVec[i][1] == 't'))
-    {
-      aTol = Draw::Atof(theArgVec[++i]);
-    }
-  }
-
-  BRepTopAdaptor_FClass2d aClassifier(aF, aTol);
+  BRepTopAdaptor_FClass2d aClassifier(aF);
   if (aClassifier.PerformInfinitePoint() == TopAbs_IN)
   {
     theDI << "The face is hole\n";
diff --git a/src/BOPTest/BOPTest_TolerCommands.cxx b/src/BOPTest/BOPTest_TolerCommands.cxx
index c8ac62d..5fac900 100644
--- a/src/BOPTest/BOPTest_TolerCommands.cxx
+++ b/src/BOPTest/BOPTest_TolerCommands.cxx
@@ -27,6 +27,7 @@
 #include <Draw.hxx>
 #include <Geom2d_Curve.hxx>
 #include <Geom_Curve.hxx>
+#include <GeomLib_CheckCurveOnSurface.hxx>
 #include <Geom_Surface.hxx>
 #include <gp_Pnt2d.hxx>
 #include <TCollection_AsciiString.hxx>
@@ -210,12 +211,8 @@ void ReduceVertexTolerance (const TopoDS_Shape& aS)
 //=======================================================================
 void ProcessEdge(const TopoDS_Edge& aE, const Standard_Real aTolTreshold)
 {
-  Standard_Integer i, aNb=23;
-  Standard_Real aD2, aTolMax2, aT1, aT2, aT, dT;
-  gp_Pnt aPC3D, aP3D;
-  gp_Pnt2d aPC2D;
+  Standard_Real aT1, aT2;
 
-  //TopTools_ListIteratorOfListOfShape anIt;// Wng in Gcc 3.0
   BRep_ListIteratorOfListOfCurveRepresentation itcr;
   //
   Handle(Geom_Curve) aC3D=BRep_Tool::Curve(aE, aT1, aT2);
@@ -223,12 +220,10 @@ void ProcessEdge(const TopoDS_Edge& aE, const Standard_Real aTolTreshold)
     return;
   }
   //
-  dT=(aT2-aT1)/aNb;
-  //
   Handle(BRep_TEdge)& TE = *((Handle(BRep_TEdge)*)&aE.TShape());
   const TopLoc_Location& Eloc = aE.Location();
   //
-  aTolMax2=-1.e6;
+  Standard_Real aTolMax2=-1.e6;
   const BRep_ListOfCurveRepresentation& aLCR=TE->Curves();
   //
   itcr.Initialize(aLCR);
@@ -250,22 +245,13 @@ void ProcessEdge(const TopoDS_Edge& aE, const Standard_Real aTolTreshold)
       }
       // Surface
       const Handle(Geom_Surface)& aS=cr->Surface();
-      //
-      // 2D-point treatment
-      for (i=0; i<=aNb; ++i) {
-        aT=aT1+i*dT;
-        if (i==aNb) {
-          aT=aT2;
-        }
-        aPC3D=aC3D->Value(aT);
-        aPC2D=aC2D->Value(aT);
-        aS->D0(aPC2D.X(), aPC2D.Y(), aP3D);
-        aP3D.Transform(L.Transformation());
-        aD2=aPC3D.SquareDistance(aP3D);
-        if (aD2 > aTolMax2) {
-          aTolMax2=aD2;
-        }
-      }
+
+      GeomLib_CheckCurveOnSurface aGLCOS(aC3D, aS, aT1, aT2);
+      aGLCOS.Perform(aC2D);
+      if (aGLCOS.IsDone())
+        continue;
+
+      aTolMax2 = aGLCOS.MaxDistance();
     } //if (cr->IsCurveOnSurface())
   }//for (; itcr.More(); itcr.Next())
 
@@ -274,10 +260,12 @@ void ProcessEdge(const TopoDS_Edge& aE, const Standard_Real aTolTreshold)
   if (aTolMax2<0.){
     return;
   }
-  //
-  //
-  aTolMax2=sqrt(aTolMax2); 
   
+  // The same constant as in 
+  // the function defining
+  // "checkcurveonsurf" DRAW-command
+  aTolMax2 *= 1.001;
+
   //printf(" aTolMax=%15.10lf, aTolWas=%15.10lf\n", aTolMax2, aTolE);
 
   Standard_Real aTolSet;
diff --git a/src/BOPTools/BOPTools_AlgoTools2D.cxx b/src/BOPTools/BOPTools_AlgoTools2D.cxx
index babb563..22d0095 100644
--- a/src/BOPTools/BOPTools_AlgoTools2D.cxx
+++ b/src/BOPTools/BOPTools_AlgoTools2D.cxx
@@ -390,7 +390,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
         if ((u > (UMin + aDelta + aUPeriod)) ||
             (u < (UMax - aDelta - aUPeriod))) {
           BRepClass_FaceClassifier aClassifier;
-          aClassifier.Perform(aF, gp_Pnt2d(u, v), BRep_Tool::Tolerance(aF));
+          aClassifier.Perform(aF, gp_Pnt2d(u, v));
           TopAbs_State Status = aClassifier.State();
           if (Status == TopAbs_OUT) {
             du += (u > (UMin + aDelta + aUPeriod)) ? -aUPeriod : aUPeriod;
@@ -406,7 +406,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
         if ((v > (VMin + aDelta + aVPeriod)) ||
             (v < (VMax - aDelta - aVPeriod))) {
           BRepClass_FaceClassifier aClassifier;
-          aClassifier.Perform(aF, gp_Pnt2d(u, v), BRep_Tool::Tolerance(aF));
+          aClassifier.Perform(aF, gp_Pnt2d(u, v));
           TopAbs_State Status = aClassifier.State();
           if (Status == TopAbs_OUT) {
             dv += (v > (VMin + aDelta + aVPeriod)) ? -aVPeriod : aVPeriod;
diff --git a/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx b/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
index a89605f..5210f15 100644
--- a/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
+++ b/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
@@ -276,7 +276,7 @@ static Standard_Boolean IsInside(const TopoDS_Wire&       wir,
     }
 
     gp_Pnt2d pt2d(C2d->Value(prm));
-    BRepTopAdaptor_FClass2d FClass2d(F,Precision::Confusion());
+    BRepTopAdaptor_FClass2d FClass2d(F);
     TopAbs_State st2=FClass2d.Perform(pt2d,Standard_False);
     return(st2 == TopAbs_IN);
   }
@@ -392,7 +392,7 @@ void BRepAlgo_FaceRestrictor::PerformWithCorrection()
     B.Add(NF,W);
     
     if (IsClosed(W)) {  
-      BRepTopAdaptor_FClass2d FClass2d(NF,Precision::Confusion());
+      BRepTopAdaptor_FClass2d FClass2d(NF);
       if(FClass2d.PerformInfinitePoint() != TopAbs_OUT) { 
         W.Reverse();
       }
diff --git a/src/BRepAlgo/BRepAlgo_NormalProjection.cxx b/src/BRepAlgo/BRepAlgo_NormalProjection.cxx
index af045b2..d9c75b5 100644
--- a/src/BRepAlgo/BRepAlgo_NormalProjection.cxx
+++ b/src/BRepAlgo/BRepAlgo_NormalProjection.cxx
@@ -495,8 +495,7 @@ void BRepAlgo_NormalProjection::SetDefaultParams()
               }
               else {
                 // if the common operation has failed, try to classify the part
-                 BRepTopAdaptor_FClass2d classifier(TopoDS::Face(Faces->Value(j)),
-                                                    Precision::Confusion());
+                 BRepTopAdaptor_FClass2d classifier(TopoDS::Face(Faces->Value(j)));
 	         gp_Pnt2d Puv;
 	         Standard_Real f = PCur2d->FirstParameter();
 	         Standard_Real l = PCur2d->LastParameter();
@@ -517,8 +516,7 @@ void BRepAlgo_NormalProjection::SetDefaultParams()
                  cout << " BooleanOperations : no solution " << endl;
 #endif
 
-              BRepTopAdaptor_FClass2d classifier(TopoDS::Face(Faces->Value(j)),
-                                                 Precision::Confusion());
+              BRepTopAdaptor_FClass2d classifier(TopoDS::Face(Faces->Value(j)));
 	      gp_Pnt2d Puv;
 	      Standard_Real f = PCur2d->FirstParameter();
 	      Standard_Real l = PCur2d->LastParameter();
diff --git a/src/BRepBndLib/BRepBndLib.cxx b/src/BRepBndLib/BRepBndLib.cxx
index 871a54b..f50990a 100644
--- a/src/BRepBndLib/BRepBndLib.cxx
+++ b/src/BRepBndLib/BRepBndLib.cxx
@@ -701,7 +701,7 @@ void AdjustFaceBox(const BRepAdaptor_Surface& BS,
   FaceBox.Get(fxmin, fymin, fzmin, fxmax, fymax, fzmax);
   EdgeBox.Get(exmin, eymin, ezmin, exmax, eymax, ezmax);
   //
-  BRepTopAdaptor_FClass2d FClass(BS.Face(), Tol);
+  BRepTopAdaptor_FClass2d FClass(BS.Face());
   const Standard_Real TolU = Max(BS.UResolution(Tol), Precision::PConfusion());
   const Standard_Real TolV = Max(BS.VResolution(Tol), Precision::PConfusion());
   //
diff --git a/src/BRepCheck/BRepCheck_Face.cxx b/src/BRepCheck/BRepCheck_Face.cxx
index 3b53dc1..da83b2c 100644
--- a/src/BRepCheck/BRepCheck_Face.cxx
+++ b/src/BRepCheck/BRepCheck_Face.cxx
@@ -323,7 +323,7 @@ BRepCheck_Status BRepCheck_Face::ClassifyWires(const Standard_Boolean Update)
     newFace.Orientation(TopAbs_FORWARD);
     B.Add(newFace,wir1);
 
-    BRepTopAdaptor_FClass2d FClass2d(newFace,Precision::Confusion());
+    BRepTopAdaptor_FClass2d FClass2d(newFace);
     Standard_Boolean WireBienOriente = Standard_False;
     TopAbs_State aState = FClass2d.PerformInfinitePoint();
     if (aState == TopAbs_UNKNOWN) {
